"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookIdentityType = exports.SortOrder = exports.FeedbackType = exports.Action = exports.Category = exports.Sender = void 0;
var Sender;
(function (Sender) {
    /** Unknown sender type. */
    Sender["UNKNOWN_SENDER"] = "UNKNOWN_SENDER";
    /** Wix user. For example, a site admin. */
    Sender["USER"] = "USER";
    /** AI assistant. */
    Sender["ASSISTANT"] = "ASSISTANT";
})(Sender || (exports.Sender = Sender = {}));
/** Category of the external document. */
var Category;
(function (Category) {
    Category["NO_CATEGORY"] = "NO_CATEGORY";
    Category["ENRICHMENT"] = "ENRICHMENT";
    /** FEEDBACK = 2; */
    Category["RESTRICTION"] = "RESTRICTION";
})(Category || (exports.Category = Category = {}));
/** Action to be taken when the external document is presented to the user. */
var Action;
(function (Action) {
    Action["NO_ACTION"] = "NO_ACTION";
    Action["NO_ANSWER"] = "NO_ANSWER";
    Action["CONTACT"] = "CONTACT";
})(Action || (exports.Action = Action = {}));
var FeedbackType;
(function (FeedbackType) {
    /** Unknown feedback type. */
    FeedbackType["UNKNOWN"] = "UNKNOWN";
    /** AI assistant provided relevant and correct information. */
    FeedbackType["THUMBS_UP"] = "THUMBS_UP";
    /** AI assistant didn't answer the question. */
    FeedbackType["IRRELEVANT"] = "IRRELEVANT";
    /** AI assistant provided incorrect information. */
    FeedbackType["INCORRECT"] = "INCORRECT";
    /** AI Assistant should not answer the question asked. */
    FeedbackType["SHOULD_NOT_ANSWER"] = "SHOULD_NOT_ANSWER";
    /** AI Assistant answered the question, but could be improved. */
    FeedbackType["OK_BUT"] = "OK_BUT";
    /** Other. */
    FeedbackType["OTHER"] = "OTHER";
})(FeedbackType || (exports.FeedbackType = FeedbackType = {}));
var SortOrder;
(function (SortOrder) {
    SortOrder["ASC"] = "ASC";
    SortOrder["DESC"] = "DESC";
})(SortOrder || (exports.SortOrder = SortOrder = {}));
var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (exports.WebhookIdentityType = WebhookIdentityType = {}));
//# sourceMappingURL=innovation-playground-v2-message-assistant-training.types.js.map